/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export interface ITestClass {
    stringProperty: string;
}

export interface IIdentifiable_string {
    id: string;
}

export type IntersectionExample = ITestClass & IIdentifiable_string;

export class TestController {
    constructor(private fetcher: IFetcher) { }
    getAll = (headers?: HeaderMap): Promise<IntersectionExample> => {
        return this.fetcher.request<IntersectionExample>(`test/all`, "get", "application/json", undefined, headers);
    };
    intersectionQuery = (query?: IntersectionExample, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`test/intersectionQuery${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}